local key = "ВашКлюч"
local city = "Moscow"
print(city)

if not dat then dat = {} end
if not wth then wth = {} end
if m then m:close(); dat.broker= false end

local answer = ''
local conn, getdata, killask, datetime
local request = "GET http://api.weatherbit.io/v2.0/forecast/daily?city="..city.."&days=2&key="..key.." HTTP/1.1\r\n" ..
"Host: api.weatherbit.io\r\n"
getdata = function ()
    -- print('answer:\n\n\n', answer,'\n\n')
    if answer == "" then
        print('Lost answer!')
    else
        dat.err = string.find(answer, 'error')
        if not dat.err then
            wth.minnow, wth.maxtemp, wth.mintemp = string.match(answer, '"min_temp":(%p*%d+.%d*).+"max_temp":(%p*%d+.%d*),.+"min_temp":(%p*%d+.%d*),".+$')
            wth.codef = string.match(answer, '"code".+"code":(%d+).+$')
            wth.tavg = string.match(answer, '"temp".+"temp":(%p*%d+.%d*),.+$')
            local datetime = string.match(answer, '"datetime".+"datetime":"(%d+-%d+-%d+)",.+$')
            print(datetime)
            wth.codef = tonumber(wth.codef) or 0
            table.foreach(wth,print)
        else
            print('\t\t\tApixu Error!!!')
            dat.err = string.match(answer, '"message":"(.+)"') or 'Error.'
            dat.errcode = string.match(answer, '"code":(%d+)') or '0'
            print('\t\t\tApixu Says:', dat.err, dat.errcode)
        end
    end
    if file.exists('mqttset.lua') then dofile'mqttset.lua' end
end

local _up_thsh = 3
local _skip_hd = true
local _chk = ''
local _cnt = 0
local i, j

local function cb_disconnected()
    --conn:close()
    conn = nil
    print('disconnected')
    getdata()
end

local function data_received(c, data)
    if killask then killask:stop(); killask:unregister(); killask = nil end

    if _skip_hd then
        _chk = _chk..data
        i, j = string.find(_chk, '\r\n\r\n')
        if i then
            _skip_hd = false
            data = string.sub(_chk, j + 1, -1)
            _chk = nil
        end
    end
    
    if not _skip_hd then
        _cnt = _cnt + 1
        answer = answer..data
        if _cnt > _up_thsh then
            cb_disconnected()
        end
    end
end
if wifi.sta.status() == 5 then
    net.dns.resolve("api.weatherbit.io", function(sk, ip)
        if (ip == nil) then
            print("Lost DNS weatherbit!")
        else
            killask = tmr.create()
            killask:alarm(10000, 0, function(_)
                if conn then
                    cb_disconnected()
                    print('\n\nConn killed!\n\n')
                end
            end)
            conn = net.createConnection(net.TCP, 0)
            conn:on("connection", function(conn, payload) conn:send(request.."Connection: close\r\nAccept: /\r\n\r\n") end)
            conn:on("disconnection", cb_disconnected)
            conn:on("receive", data_received)
            conn:connect(80, 'api.weatherbit.io')
        end
    end)
end
